import os, re, pickle, json, datetime
from TQ import *
from operator import itemgetter

os.chdir('C:/Users/batagelj/work/Python/temporal/terror')

print('start:',datetime.datetime.now().ctime())

with open("terror.p","rb") as p: V = pickle.load(p)
W = V['mat']
n = len(W); All = range(n)
names = V['nam']
times = V['tim']
print('input:',datetime.datetime.now().ctime())

act = [[]]*n; S = [0]*n
for u in range(n):
   a = []
   for v in range(n):
      a = TQ.sum(a,W[v][u] if v < u else W[u][v])
   act[u] = a
print('activity:',datetime.datetime.now().ctime())

# diag <- []; 

deg = [0]*n;
for u in range(n):
   d = []
   for v in range(n):
      d = TQ.sum(d,TQ.binary(W[v][u]) if v < u else TQ.binary(W[u][v]))
   deg[u] = d
print('degree:',datetime.datetime.now().ctime())

TQ.maxmin()
delta = []
for d in deg: delta = TQ.sum(delta,d)
TQ.combinatorial()
print('delta:',datetime.datetime.now().ctime())

att = [[]]*n
for u in range(n):
   s = []
   for v in range(n):
      if v<u : 
         if W[v][u]!=[]:
            s = TQ.sum(s,TQ.proportion(W[v][u],act[v]))
      elif u<v :
         if W[u][v]!=[]:
            s = TQ.sum(s,TQ.proportion(W[u][v],act[v]))            
   att[u] = TQ.proportion(s,delta)
print('attract:',datetime.datetime.now().ctime())

print("Attraction")
S = [0]*n
for u in range(n): S[u] = TQ.total(att[u])
P = sorted(enumerate(S),key=itemgetter(1),reverse=True)
for i in range(100):
   print(i+1,names[P[i][0]],P[i][1])
H = [ P[i][0] for i in range(50) ]

print("Activity")
T = [0]*n
for u in range(n): T[u] = TQ.total(act[u])
Q = sorted(enumerate(T),key=itemgetter(1),reverse=True)
for i in range(100):
   print(i+1,names[Q[i][0]],Q[i][1])
F = [ Q[i][0] for i in range(50) ]
Z = [[ W[u][v] for v in F] for u in F]
nams = [names[u] for u in F]

Z1 = [[TQ.filter(Z[u][v],lambda v: v>9) for u in range(50)] for v in range(50)]
TQ.Mat2Pajek(Z1,file="Z10big.net",names=nams,labels=True)

comp = {}
comp['tit'] = 'Terror news - September 11th / short'
comp['num'] = len(F)
comp['acNam'] = [names[u] for u in F]
comp['act']   = [act[i] for i in F]
comp['acTot'] = [T[i] for i in F]
comp['atNam'] = [names[u] for u in H]
comp['att']   = [att[i] for i in H]
comp['atTot'] = [S[i] for i in H]
comp['tim'] = times
comp['mat'] = Z
with open('terrCompBig.json',mode='w',encoding='utf-8') as f:
   json.dump(comp,f,indent=2)

   
