from TQ import *
import math
 
A = [ [ [] for i in range(5)] for j in range(5)]
 
A[0][1] = [(1,9,1)]
A[1][4] = [(1,9,1)]
A[1][2] = [(1,9,1)]
A[2][0] = [(1,4,1),(4,9,3)]
A[2][3] = [(1,9,1)]
A[3][2] = [(1,9,1)]
A[2][2] = [(1, 3, 1), (4, 6, 2)]

B = [ [ [] for i in range(8)] for j in range(8)] # HITS
B[0][4]=[(1,9,1)]
B[1][4]=[(1,9,1)]
B[1][6]=[(1,9,1)]
B[2][4]=[(1,9,1)]
B[2][6]=[(1,9,1)]
B[2][7]=[(1,9,1)]
B[3][5]=[(1,9,1)]
B[3][7]=[(1,9,1)]

#Katz clanek matrika; 1/a = 2
C = [ [ [] for i in range(6)] for j in range(6)]
C[0][5]=[(1,9,1)]
C[1][2]=[(1,9,1)]
C[1][5]=[(1,9,1)]
C[2][1]=[(1,9,1)]
C[2][3]=[(1,9,1)]
C[2][5]=[(1,9,1)]
C[3][0]=[(1,9,1)]
C[3][4]=[(1,9,1)]
C[4][3]=[(1,9,1)]
C[4][5]=[(1,9,1)]
C[5][0]=[(1,9,1)]
C[5][3]=[(1,9,1)]

#Linear algebra behind Google primer 1
D = [ [ [] for i in range(4)] for j in range(4)]
D[0][2]=[(1,9,1)]
D[0][3]=[(1,9,1)]
D[1][0]=[(1,9,1)]
D[2][0]=[(1,9,1)]
D[2][1]=[(1,9,1)]
D[2][3]=[(1,9,1)]
D[3][0]=[(1,9,1)]
D[3][1]=[(1,9,1)]

P = [ [ [] for i in range(6)] for j in range(6)] # dangling edge PR example 8  from http://www.sirgroane.net/google-page-rank/
P[0][1]=[(1,9,1)]
P[1][2]=[(1,9,1)]
P[1][3]=[(1,9,1)]
P[1][4]=[(1,9,1)]
P[2][1]=[(1,9,1)]
P[3][1]=[(1,9,1)]
P[3][5]=[(1,9,1)]
P[4][1]=[(1,9,1)]

W = [ [ [] for i in range(11)] for j in range(11)] # primer z wiki http://en.wikipedia.org/wiki/PageRank
W[1][2]=[(1,9,1)]
W[2][1]=[(1,9,1)]
W[3][0]=[(1,9,1)]
W[3][1]=[(1,9,1)]
W[4][1]=[(1,9,1)]
W[4][3]=[(1,9,1)]
W[4][5]=[(1,9,1)]
W[5][1]=[(1,9,1)]
W[5][4]=[(1,9,1)]
W[6][1]=[(1,9,1)]
W[6][4]=[(1,9,1)]
W[7][1]=[(1,9,1)]
W[7][4]=[(1,9,1)]
W[8][1]=[(1,9,1)]
W[8][4]=[(1,9,1)]
W[9][4]=[(1,9,1)]
W[10][4]=[(1,9,1)]



print("Matrix B");  TQ.MatList(B,all=False)

def minus(a):
    c = []
    for (sa,fa,va) in a:
        c.append((sa,fa,-va))
    return c

def VecMinus(x):
    nx = len(x)
    c = [[] for i in range(nx)]
    for i in range(nx): c[i] = minus(x[i])
    return c        

def VecDiff(a,b):
    return TQ.VecSum(a, VecMinus(b))

def MatMinus(A):
    nr = len(A); nc = len(A[0])
    B = [[[] for v in range(nr)] for u in range(nc)]
    for u in range(nr):
        for v in range(nc): B[u][v]=minus(A[u][v])
    return(B)   

def MatDiff(A,B):
    return TQ.MatSum(A,MatMinus(B))

def MatSetDiagVec(x):
      nx = len(x); nc = len(A[0])
      B = [[[] for v in range(nx)] for u in range(nx)]
      for u in range(nx): B[u][u] = x[u]
      return(B)

def sqroot(a):
    c = []
    for (sa,fa,va) in a:
        c.append((sa,fa,sqrt(va)))
    return c

def factorial(a):
    c = []
    for (sa,fa,va) in a:
        c.append((sa,fa,math.factorial(va)))
    return c

def skalProd(x,y):
    nx = len(x); ny = len(y);
    # if nx != ny: error
    s = []
    for i in range(nx): s = TQ.sum(s, TQ.prod(x[i],y[i]))
    return s

def norm2(x):
    s = skalProd(x,x)
    s = sqroot(s)
    return s

def norm1(x):
    s = []
    n = len(x)
    for i in range(n): s = TQ.sum(s,x[i])
    s = numInv(s)
    x = numVecProd(s,x)
    return x

def numInv(a):
    c=[]
    for (sa,fa,va) in a:
        c.append((sa,fa,1/va))
    return c

def vecInv(x):
    nx = len(x)
    c = [[] for i in range(nx)]
    for i in range(nx): c[i] = numInv(x[i])
    return c

def numVecProd(a,x):
    nx = len(x)
    c = [[] for i in range(nx)]
    for i in range(nx): c[i] = TQ.prod(a,x[i])
    return c

def numMatProd(a,A):
    nr = len(A); nc = len(A[0])
    B = [[[] for v in range(nr)] for u in range(nc)]
    for u in range(nr):
        for v in range(nc): B[u][v]=TQ.prod(a,A[u][v])
    return(B)

def constantMat(n,const=TQ.sE):
   return([ [const for i in range(n)] for j in range(n) ])

def MatEye(n):
   A = [[ [] for i in range(n)] for j in range(n)]
   for u in range(n): A[u][u] = [(1,TQ.inf,1)]
   return(A)

def diag(A):
    nr = len(A); nc = len(A[0])
    n = min(nr,nc)
    c = [[] for i in range(n)]
    for u in range(n): c[u] = A[u][u]
    return c

def jacobi(A,b,x0,delta=1E-6,maxsteps=100):
    d = diag(A)
    invD = MatSetDiagVec(vecInv(d))
    Aoff = MatDiff(A,MatSetDiagVec(d))
    
    xn = TQ.MatVecLeft(invD,TQ.VecSum(TQ.MatVecRight(MatMinus(Aoff),x0),b))
    steps = 1;
    while (steps < maxsteps): # se pogoj s toleranco; norm(xn - x0) >= delta
        steps = steps+1
        x0=xn
        xn = TQ.MatVecLeft(invD,TQ.VecSum(TQ.MatVecRight(MatMinus(Aoff),x0),b))
    return xn

def eigTemp(A,x,tol=1E-6, stIter=100):
    i=0
    while i < stIter:
        x_old = x
        y = TQ.MatVecRight(A,x)
        n = norm2(y)
        nInv = numInv(n)
        x = numVecProd(nInv,y)
        ax = TQ.MatVecRight(A,x)
        ev = skalProd(x,ax)
        x_dif = VecDiff(x,x_old)
        tolDif = TQ.VecSummary(norm2(x_dif))[3]
        if tolDif < tol: break
        i=i+1
    return (x,ev) #x l.vekt; ev l.vrednost

def hits(A):
    x = TQ.VecConst(len(A))
    y = TQ.VecConst(len(A))
    B = TQ.MatProd(A,TQ.MatTrans(A))
    C = TQ.MatProd(TQ.MatTrans(A),A)
    (x,evx)=eigTemp(C,x)
    (y,evy)=eigTemp(B,y)
    return (x,y)

def katz_orig(C,a): # a je konstanta - stevilo; izbrano
    n = len(C)
    A = [[ [] for i in range(n)] for j in range(n)]
    for u in range(n): A[u][u] = [(1,TQ.inf,1/a)]
    A = MatDiff(A,TQ.MatTrans(C))
    s = TQ.MatVecLeft(C,TQ.VecConst(n))
    t = jacobi(A,s,TQ.VecConst(n)) # poglej casovne intervale!!! nekje so do 9; pri konstantah so do inf - problem?!
    m = math.factorial(n-1)*(a**(n-1))*math.exp(1/a)
    m = [(1,TQ.inf,1/m)]
    return numVecProd(m,t)

def katz(C): # a je konstanta, vecja od max stolpcnih vsot; vzrok je konvergenca J. iteracije
    n = len(C)
    s = TQ.MatVecLeft(C,TQ.VecConst(n))
    
    max = 0
    for i in range(len(s)): 
        if TQ.VecMax(s[i]) > max: max = TQ.VecMax(s[i])
    a = 1/(max+1)
    
    A = [[ [] for i in range(n)] for j in range(n)]
    for u in range(n): A[u][u] = [(1,TQ.inf,1/a)]
    A = MatDiff(A,TQ.MatTrans(C))
    s = TQ.MatVecLeft(C,TQ.VecConst(n))
    t = jacobi(A,s,TQ.VecConst(n)) # poglej casovne intervale!!! nekje so do 9; pri konstantah so do inf - problem?!
    m = math.factorial(n-1)*(a**(n-1))*math.exp(1/a)
    m = [(1,TQ.inf,1/m)]
    return numVecProd(m,t)

def pageRank1(T): # osnovna verzija - no dangling ends, strongly connected
    n=len(T)
    A = [[ [] for i in range(n)] for j in range(n)]
    s = TQ.MatVecLeft(T,TQ.VecConst(n)) # stolpicne vsote
    s = vecInv(s)
    A = TQ.MatProd(T, MatSetDiagVec(s)) # vsak stolpec osnovne matrike delim z vsoto stolpca
    x0 = TQ.VecConst(n)
    (x,ev) = eigTemp(A,x0)
    x = norm1(x)
    return x

def pageRank(T): # prirejena verzija - no dangling ends, vec komponent; m = 0.15 standardna izbira # PAZI NA VRSTNI RED V MATRIKI!!!!! KATERI SO IN KATERI SO OUT!!!! PRemisli!!!
    n=len(T)
    A = [[ [] for i in range(n)] for j in range(n)]
    s = TQ.MatVecLeft(T,TQ.VecConst(n)) # stolpicne vsote
    s = vecInv(s)
    A = TQ.MatProd(T, MatSetDiagVec(s)) # vsak stolpec osnovne matrike delim z vsoto stolpca
    
    m=0.15   
    S = constantMat(n,[(1,TQ.inf,1/n)])
    M = TQ.MatSum(numMatProd([(1,TQ.inf,1-m)],A),numMatProd([(1,TQ.inf,m)],S))
    
    x0 = TQ.VecConst(n)
    (x,ev) = eigTemp(M,x0)
    x = norm1(x)
    return x



# (x,y)=hits(B)
# print(x)
# print(y)
# 
# x = TQ.VecConst(len(A))
# (xe,ev) = eigTemp(A,x)
# TQ.VecList(xe)

# print(MatMinus(A))
# print(diag(A))
# print(MatSetDiagVec(diag(A)))

# M = [ [ [] for i in range(3)] for j in range(3)]
# 
# M[0][0]=[(1,9,3)]
# M[0][1]=[(1,9,1)]
# M[0][2]=[(1,9,1)]
# M[1][0]=[(1,9,2)]
# M[1][1]=[(1,9,4)]
# M[1][2]=[(1,9,1)]
# M[2][0]=[(1,9,2)]
# M[2][1]=[(1,9,2)]
# M[2][2]=[(1,9,5)]
# 
# b = [[(1,9,1)],[(1,9,2)],[(1,9,3)]]
# x0 = [[(1,9,1)],[(1,9,1)],[(1,9,1)]]
# 
# print(jacobi(M,b,x0))


#print(katz(B))
# a = [(1,TQ.inf,0.3)]
# R = [ [ [] for i in range(2)] for j in range(2)]
# R[0][0]=[(1,9,1)]
# print(numMatProd(a,R))
rez = pageRank(TQ.MatTrans(W))

for i in range(len(rez)):
    print(rez[i][0][2]*100)
